<?php
/**
 * An extension that allows users to upload stl files in a zip and render them.
 * This extension is based on MultiUpload.
 * Don't forget to change the include-path in the render.pov file to the absolute location of the unzip-directory.
 *
 * @file
 * @ingroup Extensions
 * @author Tanguy Monheim
 * 
 * TODO: Below is a list of known bugs. I don't know how to fix these bugs, but if you know feel free to tell me.
 * 	- The page title has < and > around it. This should be removed
 * 	- The page will always ignore warnings, but shows the user the option to not ignore them. This option should be removed in the form.
 *  - The upload form should be re-made
 *  - A hack is used to allow uploading multiple files, this could be re-made.
 */

//Set the location of the upload-button here:
$button="http://tman.webhop.net:8765/wiki/images/2/28/Upload.png";

//Make sure it is inside mediawiki
if ( ! defined( 'MEDIAWIKI' ) )
    die('This extension can only be used with mediawiki.');

// Extension credits that will show up on Special:Version
$wgExtensionCredits['specialpage'][] = array(
	'path' => __FILE__,
	'name' => 'Upload3D',
	'author' => 'Tanguy Monheim',
	'version' => '0.1',
	'description' => 'Allows users to upload stl files in a zip and render them.',
	'descriptionmsg' => 'Upload3D-desc',
);

// Set up the new special page
$dir = dirname(__FILE__) . '/';
require_once($dir . 'SpecialUpload3D.messages.php');
$wgAutoloadClasses['Upload3D'] = $dir . 'SpecialUpload3D.body.php';
$wgAutoloadClasses['UploadForm3D'] = $dir . 'SpecialUpload3D.body.php';
$wgAutoloadClasses['Button'] = $dir . 'SpecialUpload3D.php';
$wgExtensionMessagesFiles['Upload3D'] = $dir . 'SpecialUpload3D.messages.php';
$wgExtensionAliasesFiles['Upload3D'] = $dir . 'SpecialUpload3D.messages.php';
$wgSpecialPages['Upload3D'] = 'Upload3D';
$wgSpecialPageGroups['Upload3D'] = 'media';

// Hooked functions
$wgHooks['SkinTemplateToolboxEnd'][]  = 'wfUpload3DToolbox';

// Add the link to Special:Upload3D to all SkinTemplate-based skins for users with the 'upload' user right
function wfSpecialUpload3DNav( &$skintemplate, &$nav_urls, &$oldid, &$revid ) {
	global $wgUser;
	wfLoadExtensionMessages( 'Upload3D' );
	if( $wgUser->isAllowed( 'upload' ) )
		$nav_urls['Upload3D'] = array(
			'text' => wfMsg( 'Upload3D_link' ),
			'href' => $skintemplate->makeSpecialUrl( 'Upload3D' )
		);

	return true;
}

// Add the link to Special:Upload3D to the Monobook skin
function wfUpload3DToolbox( &$monobook ) {
	global $button;
	print "<a href='".curPageDir()."Special:Upload3D'><img src='$button' /></a>";
	return true;
}

function curPageDir(){
	$result = $_SERVER["PHP_SELF"];
	$result = substr($result, 0, strrpos($result, "/")+1);
	return $result;
}
?>